/* vi:set cindent: */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "getopt.h"
#include <stdarg.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "WebForm.h"

int debug;

int
sockprintf (int socket, char *format,...)
{
  va_list ap;
  char buf[10240];

  va_start (ap, format);
  vsprintf (buf, format, ap);
  va_end (ap);
  return write (socket, buf, strlen (buf));
}

char *packnumber(char *number)
{
    char *s1,*s2;
    
    s1 = s2 = number;
    while (*s1 != 0) {
	 if (*s1 != '-')
	     *s2++ = *s1;
	 s1++;
    }
    *s2 = 0;
    return number;
}

int
pagesend (char *number, char *password, unsigned char *message)
{
  WebForm form;
 
  printf("Sending message to %s...",number);
  fflush(stdout);

      form.Reset();
      form.SetHost("www.paging.cz");
      form.SetURL("/scripts/send_msg.php");
      form.SetReferer("http://www.pogo.cz/");
      form.SetUserAgent("Mozilla/4.0 (compatible; sms; Linux)");
      form.SetPOSTParam("ID",number);
      form.SetPOSTParam("IDPW",(char*)(password?password:""));
      form.SetPOSTParam("submit","Odeslat");
      form.SetPOSTParam("TXT",(char *)message);
      form.Fetch();

	    if (form.FindText("na pager")) {
		printf("Message sent successfully.\n");
	        return 0;
	    }
	  printf("\nWarning: bad HTML code, please contact the author.\n");
          return -1;
}

void usage(char *progname)
{
    printf("Usage: %s [-d] [-l] [-n email@address] [phone number(s)]\n"
	   "       %s -V\n"
	   "       %s -h\n"
	   "\n"
	   "Options:\n"
	   "    -d            Debug mode\n"
	   "    -h            Show this help screen\n"
	   "    -l            Line mode, for use with NNTP (not implemented)\n"
	   "    -p password   Pager password\n"
	   "    -V            Display version\n",
	   progname, progname, progname);
}

int main(int argc, char **argv)
{
    char *message;
    char line[0x100];
    char *pageno;
    char *password;
    int havephone;
    char *progname;
    char ch;
    int errs;
    
    progname = argv[0];
    debug = 0;
    
    while ((ch = getopt(argc, argv, "Vhn:d"))!=-1) {
	switch(ch) {
	    case 'V':
		printf("Version 0.1 (compiled on " __DATE__ ")\n");
		break;
	    case 'h':
		usage(progname);
		exit(0);
 	    case 'p':
		password = optarg;
		break;
	    case 'l':
		break;
            case 'd':
		debug = 1;
		break;
	    default:
		fprintf(stderr,"Invalid option %c, try %s -h\n", ch, progname);
		exit(1);
	}
    }
    
    argc -= optind;
    argv += optind;
	
    havephone = argc!=0;

    message = (char *)malloc(1024);
   
    if (!havephone) {
      printf("Enter pager number: ");
      pageno = (char *)malloc(1024);
      fgets(pageno, 1024, stdin);
      if (pageno[strlen(pageno)-1] == '\n')
	  pageno[strlen(pageno)-1] = 0;
    }

    if (isatty(STDIN_FILENO)) 
	printf("Enter your message, end with '.':\n");

    message[0] = 0;    
    while (1) {
	if (isatty(STDIN_FILENO)) {
           printf("> ");
	   fflush(stdout);
        }
	if (fgets(line,0x100,stdin) == NULL)
	    break;
	if (line[strlen(line)-1] == '\n')
	    line[strlen(line)-1] = 0;
	if (!strcmp(line,"."))
	    break;
	if (message[0] && strlen(message)<1023)
	   strcat(message," ");
	if (strlen(message)+strlen(line)<1024)
		strcat(message,line);
	else {
	    memcpy(message, line, 1023-strlen(message));
	    message[1023] = 0;
	    printf("Warning: Message too long, truncated\n");
	    break;
	}
    }
 
    errs = 0;   
    if (havephone) {
	while(argc--) {
            if ( pagesend(argv[0], password, (unsigned char *)message) < 0)
		errs++;
	    argv++;
	}
    }else{
	if ( pagesend(pageno, password, (unsigned char *)message) < 0)
	     errs++;
    }
    
    if (errs) {
	fprintf(stderr, "Error(s), some messages were not send!\n");
	exit(1);
    }else {
	printf("Ok, all messages sent to SMS center.\n");
	exit(0);
    }
    
    return 0;
}
