/* vi:set cindent: */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "getopt.h"
#include <stdarg.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#include "WebForm.h"

int debug;

int
sockprintf (int socket, char *format,...)
{
  va_list ap;
  char buf[10240];

  va_start (ap, format);
  vsprintf (buf, format, ap);
  va_end (ap);
  return write (socket, buf, strlen (buf));
}

char *packnumber(char *number)
{
    char *s1,*s2;
    
    s1 = s2 = number;
    while (*s1 != 0) {
	 if (*s1 != '-')
	     *s2++ = *s1;
	 s1++;
    }
    *s2 = 0;
    return number;
}

int
smssend (char *number, char *email, unsigned char *message,char *user, char *password)
{
  WebForm form;
  char *sessionid;
  char *str_delay;
  char *num;
  char msg[161];
  int i;
 
  num = strdup(number);
  if (!num) {
      fprintf(stderr, "malloc: Not enough memory!\n");
      return -1;
  }
  
  packnumber(num);

  printf("Sending message to %s via 1stwap.com ...",num);
  fflush(stdout);

  memset(msg,'.', sizeof(msg));
  msg[160] = 0;
  memcpy(msg, message, strlen((char *)message) < 160 ? strlen((char *)message) : 160);

  if (debug)
      form.DebugMode(1);
  

  printf("INTRO ");
  form.Reset();
  form.SetHost("www.1rstwap.com");
  form.SetURL("/partners/go.to/1rstwap");
  form.SetReferer("http://www.1rstwap.com/");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.Fetch();
 
  sessionid = form.FindValue("&PHPSESSID=", '&'); 

  if (debug)
	  printf("Session ID is %s\n", sessionid);


  printf("LOGIN ");
  form.Reset();
  form.SetHost("www.1rstwap.com");
  form.SetURL("/partners/go.php");
  form.SetReferer("http://www.1rstwap.com/partners/go.to/1rstwap");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.SetURLParam("pid","login");
  form.SetPOSTParam("Passwd",password);
  form.SetPOSTParam("UserID",user);
  form.SetURLParam("PHPSESSID",sessionid);
  form.Fetch();

   if (form.FindText("pid=home") == 0) {
        printf("Login incorrect.\n");
        return 0;
    }


  printf("SEND ");
   //pid=addressbook&aid=smswindow&step=openfmenu
  form.Reset();
  form.SetHost("www.1rstwap.com");
  form.SetURL("/partners/go.php");
  form.SetReferer("http://www.1rstwap.com/partners/go.to/1rstwap");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.SetURLParam("pid","addressbook");
  form.SetURLParam("aid","smswindow");
  form.SetURLParam("step","send");
  form.SetURLParam("PHPSESSID",sessionid);
  form.SetPOSTParam("hp",number);
  form.SetPOSTParam("m",msg);
  form.Fetch();


  

  if (form.FindText("Your message has been sent to Queue")) {
        printf("Message sent successfully.\n");
  form.Reset();
  form.SetHost("www.1rstwap.com");
  form.SetURL("/partners/go.php");
  form.SetReferer("http://www.1rstwap.com/partners/go.to/1rstwap");
  form.SetUserAgent("Mozilla/4.0 (compatible; sms; Unix)");
  form.SetURLParam("pid","logout");
  form.SetURLParam("PHPSESSID",sessionid);
  form.Fetch();

  free(sessionid);

        return 0;
           }

  if (form.FindText("have exceeded")) {
        printf("Quota exceeded !!!\n");
	return 0;
  }
 

            printf("\nWarning: bad HTML code, please contact the author.\n");
         return -1;

}

void usage(char *progname)
{
    printf("Usage: %s [-d] [-l] [-n email@address] [phone number(s)]\n"
	   "       %s -V\n"
	   "       %s -h\n"
	   "\n"
	   "Options:\n"
	   "    -d            Debug mode\n"
	   "    -h            Show this help screen\n"
	   "    -l            Line mode, for use with NNTP (not implemented)\n",
	   "    -p password   MTN SMS password\n",
	   "    -u username  MTN SMS login\n",
	   "    -n email      Send delivery notification via e-mail\n"
	   "    -V            Display version\n",
	   progname, progname, progname);
}

int main(int argc, char **argv)
{
    char *email;
    char *message;
    char line[0x100];
    char *phoneno;
    int havephone;
    char *progname;
    char *username;
    char *password;
    char ch;
    int errs;
    
    progname = argv[0];
    debug = 0;
    
    while ((ch = getopt(argc, argv, "Vhn:du:p:"))!=-1) {
	switch(ch) {
	    case 'V':
		printf("Version 0.1 (compiled on " __DATE__ ")\n");
		break;
	    case 'h':
		usage(progname);
		exit(0);
 	    case 'n':
		email = optarg;
		break;
 	    case 'u':
		username = optarg;
		break;
 	    case 'p':
		password = optarg;
		break;

	    case 'l':
		break;
            case 'd':
		debug = 1;
		break;
	    default:
		fprintf(stderr,"Invalid option %c, try %s -h\n", ch, progname);
		exit(1);
	}
    }
    
    argc -= optind;
    argv += optind;
	
    havephone = argc!=0;

    email = 0;
    
    message = (char *)malloc(1024);
   
    if (!havephone) {
      printf("Enter phone number: ");
      phoneno = (char *)malloc(1024);
      fgets(phoneno, 1024, stdin);
      if (phoneno[strlen(phoneno)-1] == '\n')
	  phoneno[strlen(phoneno)-1] = 0;
    }

    if (isatty(STDIN_FILENO)) 
	printf("Enter your message, end with '.':\n");

    message[0] = 0;    
    while (1) {
	if (isatty(STDIN_FILENO)) {
           printf("> ");
	   fflush(stdout);
        }
	if (fgets(line,0x100,stdin) == NULL)
	    break;
	if (line[strlen(line)-1] == '\n')
	    line[strlen(line)-1] = 0;
	if (!strcmp(line,"."))
	    break;
	if (message[0] && strlen(message)<1023)
	   strcat(message," ");
	if (strlen(message)+strlen(line)<1024)
		strcat(message,line);
	else {
	    memcpy(message, line, 1023-strlen(message));
	    message[1023] = 0;
	    printf("Warning: Message too long, truncated\n");
	    break;
	}
    }
 
    errs = 0;   
    if (havephone) {
	while(argc--) {
            if ( smssend(argv[0], email, (unsigned char *)message, username, password) < 0)
		errs++;
	    argv++;
	}
    }else{
	if ( smssend(phoneno, email, (unsigned char *)message, username, password) < 0)
	     errs++;
    }
    
    if (errs) {
	fprintf(stderr, "Error(s), some messages were not send!\n");
	exit(1);
    }else {
	printf("Ok, all messages sent to SMS center.\n");
	exit(0);
    }
    
    return 0;
}
